(document:surround "/std/frame")
(document:insert "/std/functions")

(document:insert "/net-junior/common-functions")
(document:insert "/net-junior/base-functions")
(document:insert "/net-junior/install-functions")

(document:envelop with-translation _ "alterator-net-junior")
;; XXX:
;;   (format #t "~S\n" data)

;;;;;;;;;;;;;;;;;;;;;;;;;
(gridbox
 columns "20;60;20"
 (spacer)
 (hbox
  (vbox
   (label (bold (_ "Fully qualified host name:")))
   (spacer))
  (vbox
   (document:id hostname (edit "" widget-name "hostname"))
      (document:id conf_auto
       (checkbox (_ "configure all suitable ethernet interfaces automatically")
        state #t
        tooltip (_ "Configure all suitable ethernet interfaces via Zeroconf or DHCP")
        (when toggled (conf_type_changed))))))
(spacer))

(define (net-wifi name)
  (and (not-empty-string? name)
       (document:popup "/net-wifi/" 'interface name)))

(document:id
 interfaces_group
 (groupbox
  (_ "Interfaces Configuration:")
  (gridbox
   columns "20;60;20"
   (spacer)
   (hbox
    (vbox
     (label (_ "Interface:"))
     (label (_ "Status:"))
     (label (_ "Options:")))
    (vbox
     (document:id ifaces (combobox ""))
     (document:id iface-info (edit "" activity #f))
     (hbox 
     (document:id iface-conf
                  (combobox ""
                            rows `(
                                   ,(_ "Manually set IP address")
                                   ,(_ "Obtain IP address settings with DHCP")
                                   ,(_ "IPv4LL client (zeroconf)")
                                   ,(_ "Ignore the interface"))
                            (when selected (iface_conf_type_changed))))
     (document:id w-button (button (_ "Wireless settings"))))))
   (spacer))

  (w-button (when clicked (net-wifi (current-interface))))

  ;; Statical address
       ;; (label (_ "Additional wireless settings")) spacing 15)
  (document:id
   iface_statical_conf
    (gridbox
     columns "100"
     (hbox
      (vbox
       (label (_ "IP Address:"))
       (label (_ "Subnet Mask:"))
       (label (_ "Default Gateway IP: (optional)")))
      (vbox
       (document:id iface-ip (edit "" widget-name "iface-ip"))
       (document:id iface-mask (combobox "" rows (map cdr avail-masks)))
       (document:id iface-gw (edit "" widget-name "iface-gw"))))))
  (document:id
   iface_dhcp_conf
    (gridbox
     columns "50;50"
     (vbox
      (document:id dhcp-gw (checkbox (_ "Install default routes provided by DHCP server") widget-name "dhcp-gw"))
      (document:id dhcp-dns (checkbox (_ "Automatically obtain DNS information") widget-name "dhcp-dns"))
      (document:id dhcp-hostname (checkbox (_ "Set hostname and domainname supplied by DHCP server") widget-name "dhcp-hostname"))
      (document:id dhcp-ntp (checkbox (_ "Set NTP configuration recived from DHCP server") widget-name "dhcp-ntp")))
     (vbox
      (document:id dhcp-conf (listbox rows '())))))))

(document:id
 dns_group
 (groupbox
  (_ "Additional Options:")
  (gridbox
   columns "100"
   (hbox
    (vbox
     (label (_ "Primary DNS:"))
     (label (_ "Secondary DNS:"))
     (label (_ "Ternary DNS:")))
    (vbox
     (document:id dns-1 (edit "" widget-name "dns-1"))
     (document:id dns-2 (edit "" widget-name "dns-2"))
     (document:id dns-3 (edit "" widget-name "dns-3"))))
   (hbox
    (label (_ "Search list for hostname lookup: (via spaces)"))
    (document:id dns-search (edit ""))))))


(or (global 'frame:next)
    (hbox align "center"
          (document:id c-button (button (_ "Apply")))
          (document:id r-button (button (_ "Reset")))
          (document:id q-button (button (_ "Quit")))))

(if (global 'frame:next)
    (install-behaviour)
    (base-behaviour))

; Startup procedure and automatical constraints
(document:root
 (when loaded
   (begin
     (startup)
     (update-constraints "write" "/net-junior"))))
